'use strict';

var ListaComposicaoController = angular.module('ListaComposicaoController', []);

ListaComposicaoController.controller('ListaComposicaoCtrl', ['$scope', '$routeParams', 'Construcao', 'Material', 'UploadApp', 'MsgBox', 'CacheApp',
($scope, $routeParams, Construcao, Material, UploadApp, MsgBox, CacheApp) => {

    $scope.getComposicoes = (callBack) => {
        var params = {
            IdConstrucao: $scope.construcao.Id,
            Nome: $scope.pesquisa ? $scope.pesquisa : '',
            Pages: $scope.paginacao.Pages,
            Index: $scope.paginacao.Index
        }

        $scope.paginacao.Load = true;
        Material.getBuscaComposicao(params,
        // Construcao.getComposicoes($scope.construcao.Id,
            (data) => {
                if (!$scope.composicoes)
                    $scope.composicoes = data.Instance
                else {
                    $scope.composicoesAtualizadas = data.Instance
                    data.Instance.forEach(comp => {
                        var oldComp = $scope.composicoes.filter(c => c.Id == comp.Id)[0]
                        if (oldComp) {
                            oldComp.IdCount = comp.IdCount
                            oldComp.Id = comp.Id
                            oldComp.Codigo = comp.Codigo
                            oldComp.Tipo = comp.Tipo
                            oldComp.Ordem = comp.Ordem
                            oldComp.Descricao = comp.Descricao
                            oldComp.Unidade = comp.Unidade
                            oldComp.Custo = comp.Custo
                            oldComp.CustoBDI = comp.CustoBDI
                            oldComp.CustoEncargos = comp.CustoEncargos
                            oldComp.CustoTotal = comp.CustoTotal
                            oldComp.Itens = comp.Itens
                        }
                        else {
                            var composicao = {
                                Id: comp.Id,
                                Codigo: comp.Codigo,
                                Tipo: comp.Tipo,
                                Ordem: comp.Ordem,
                                Descricao: comp.Descricao,
                                Unidade: comp.Unidade,
                                Custo: comp.Custo,
                                CustoBDI: comp.CustoBDI,
                                CustoEncargos: comp.CustoEncargos,
                                CustoTotal: comp.CustoTotal,
                                Itens: comp.Itens
                            }
        
                            $scope.composicoes.push(composicao);
                        }
                    });
                }

                $scope.paginacao.Load = false;
                if (callBack)
                    callBack();
            });
    }

    $scope.aplicaFiltro = () => {
        clearTimeout($scope.timer); 
        $scope.timer = setTimeout( () => {
            $scope.inicializaPaginacao(); 
            $scope.getComposicoes(()=>{})
        }, 1000);
    }

    $scope.inicializaPaginacao = () => {
        $scope.composicoes = undefined;
        $scope.paginacao = {
            Index: 0,
            Pages: 20
        };
    }

    $scope.getOrigemBase = () => {
        Material.getOrigemBaseComposicao(
            (data) => {
                $scope.listaOrigemDisponivel = data.Instance
                $scope.sessao.BasePublica = ($scope.sessao.BasePublica && $scope.sessao.BasePublica.IdBaseOrigem) ? $scope.sessao.BasePublica : {IdBaseOrigem: '0', IdOrigem: '0'}
                $scope.getComposicaoDisponivel($scope.sessao.BasePublica)
            });
    }

    $scope.getComposicaoDisponivel = (item) => {
        var params = {
            Origem: item.IdBaseOrigem
        }
        Material.getBaseComposicao(params,
            (data) => {
                $scope.listaComposicaoDisponivel = data.Instance;
                if (!$scope.sessao.BasePublica || $scope.sessao.BasePublica.IdBaseOrigem != item.IdBaseOrigem) {
                    item.IdOrigem = $scope.listaComposicaoDisponivel[0].Id.toString();
                    $scope.setBaseSessao(item);
                }

            });
    }

    // $scope.getComposicao = (composicao) => {
    //     if (composicao.editando) return;
    //     composicao.open = !composicao.open;
    //     composicao.HtmlSubItem = composicao.open ? $scope.getHtmlListaInsumoComp() : null;
    //     // composicao.HtmlSubItemMobile = composicao.open ? $scope.getHtmlListaInsumoMobile : null;
    //     if (composicao.open) {
    //         composicao.Itens = $scope.composicoes.filter(c => c.Id == composicao.IdMaterial)[0].Itens;
    //         composicao.Itens.forEach(i => {
    //             i.Caminho = [composicao.IdMaterial];
    //         })
    //     }
    // }

    $scope.getComposicaoUpdate = (composicao) => {

        function updateRecursive (lista, oldComp, newComp) {
            if (!lista || lista.length == 0)
                return true
            else {
                var oc = oldComp.Itens.filter(i => i.Id == lista[0])[0];
                var nc = newComp.Itens ? 
                    newComp.Itens.filter(i => i.Id == lista[0])[0] : 
                    $scope.composicoes.filter(c => c.Id == lista[0])[0];

                oc.EncargoSocial = nc.EncargoSocial;
                oc.BDI = nc.BDI;
                oc.ValorUnitario = nc.ValorUnitario ? nc.ValorUnitario : nc.Custo;
                oc.CustoTotal = nc.CustoTotal;
                oc.CustoBDI = nc.CustoBDI;
                oc.CustoEncargos = nc.CustoEncargos;
                oc.Custo = nc.Custo;

                lista.splice(0,1);

                updateRecursive(lista, oc, nc);
            }
        }

        var comp = [];

        if (composicao.Caminho) {
            if (composicao.Caminho.length > 1) {
                var lista = composicao.Caminho.filter(c => c != 0);
                var oldComp = $scope.composicoes.filter(c => c.Id == lista[0])[0];
                var newComp = $scope.composicoesAtualizadas.filter(c => c.Id == lista[0])[0];
                lista.splice(0,1);

                updateRecursive(lista,oldComp,newComp);
                comp = $scope.composicoes.filter(c => c.Id == composicao.Id)[0];
                composicao.Itens = comp.Itens;
            }
            else {
                var compRaiz = $scope.composicoes.filter(c => c.Id == composicao.Caminho[0])[0];
                composicao.Itens = $scope.composicoes.filter(c => c.Id == composicao.Id)[0].Itens;
                comp =  compRaiz.Itens.filter(c => c.Id == composicao.Id)[0];
            }

            var caminho = composicao.Caminho.filter(c => c!= 0);
            caminho.push(composicao.Id);
            composicao.Itens.forEach(c => {
                c.Caminho = caminho;
            })
        }
        else {
            comp = $scope.composicoes.filter(c => c.Id == composicao.IdMaterial)[0];
            composicao.Itens = comp.Itens;

            composicao.Itens.forEach(c => {
                c.Caminho = [composicao.IdMaterial];
            })
        }


        composicao.EncargoSocial = comp.EncargoSocial;
        composicao.BDI = comp.BDI;
        composicao.ValorUnitario = comp.ValorUnitario ? comp.ValorUnitario : comp.Custo;
        composicao.CustoTotal = comp.CustoTotal;
        composicao.CustoBDI = comp.CustoBDI;
        composicao.CustoEncargos = comp.CustoEncargos;
        composicao.Custo = comp.Custo;

    }

    $scope.setBaseSessao = (base) => {
        $scope.sessao.BasePublica = {IdBaseOrigem: base.IdBaseOrigem, IdOrigem: base.IdOrigem}
        CacheApp.setSessao($scope.sessao)
    }
    
    $scope.getListaItem = (composicao) => {
        composicao.open = !composicao.open
        composicao.HtmlSubItem = composicao.open ? $scope.getHtmlListaInsumoComp(composicao) : null
        // composicao.HtmlSubItemMobile = composicao.open ? $scope.getHtmlListaInsumoMobile() : null
    }

    $scope.getListaUnidades = () => {
        Material.getListaUnidades(
            (data) => {
                $scope.listaUnidade = data.Instance;
                for (let i = 0; i < $scope.listaUnidade.length; i++) {
                    const TextoUnidadeView = `${$scope.listaUnidade[i].Descricao} (${$scope.listaUnidade[i].Sigla})`
                    $scope.listaUnidade[i].TextoUnidadeView = TextoUnidadeView;
                }
            }
        );
    }

    $scope.adicionarComposicao = () => {
        var idCount = $scope.composicoes.length;
        var comp = {
            Id: 0,
            Novo: true,
            Tipo: '4',
            Codigo: '',
            Ordem: '',
            Descricao: '',
            Unidade: '',
            Itens: [],
            IdCount: idCount,
            Editar: $scope.getHtmlComposicao()
                // $scope.getHtmlEditarInsumo() // $scope.getHtmlItem()
        }
        comp.ItemEditar = $scope.getHtmlListaInsumoComp(comp)
        $scope.composicoes.unshift(comp);
        // $scope.adicionarInsumo(comp)
    }

    $scope.alterarComposicao = (composicao) => {
        for (var i in composicao.Itens) {
            var item = composicao.Itens[i];
            item.Consumo = item.Coeficiente ? item.Coeficiente : '';
            item.CustoUnitario = item.ValorUnitario ? item.ValorUnitario : '';

            item.Old = {
                Consumo: item.Consumo,
                CustoUnitario: item.CustoUnitario,
                Descricao: item.Descricao,
                Tipo: item.Tipo,
                Origem: item.Origem
            };
        }
        composicao.Old = {
            Descricao: composicao.Descricao,
            Unidade: composicao.Unidade,
            Codigo: composicao.Codigo,
            Ordem: composicao.Ordem
        };

        composicao.Novo = !composicao.Novo;
        composicao.Editar = $scope.getHtmlComposicao();
        composicao.ItemEditar = $scope.getHtmlItem();
    }

    $scope.cancelarComposicao = (composicao) => {
        if (composicao.Id == 0) {
            var idx = $scope.composicoes.indexOf(composicao)
            $scope.composicoes.splice(idx, 1);
        }
        else {

            for (var i in composicao.Itens) {
                var item = composicao.Itens[i];

                if (!item.Old) {
                composicao.Itens.splice(i,1);
                continue;
                }

                item.Consumo = item.Old.Consumo;
                item.CustoUnitario = item.Old.CustoUnitario;
                item.Descricao = item.Old.Descricao;
                item.Tipo = item.Old.Tipo;
                item.Origem = item.Old.Origem;
                delete item.Old;
            }
            composicao.Descricao = composicao.Old.Descricao;
            composicao.Unidade = composicao.Old.Unidade;
            composicao.Codigo = composicao.Old.Codigo;
            composicao.Ordem = composicao.Old.Ordem;

            composicao.Novo = !composicao.Novo;
            delete composicao.Old;
        }
    }

    $scope.adicionarItem = (composicao) => {
        var idCount = composicao.Itens.length;
        composicao.Itens.unshift({
            Id: 0,
            Tipo: '',
            Codigo: '',
            Unidade: '',
            Descricao: '',
            Ordem: '',
            CustoUnitario: '',
            Consumo: '',
            Origem: '0',
            IdCount: idCount
        });
    }

    $scope.cancelarItem = (composicao, item) => {
        var idx = composicao.Itens.indexOf(item)
        composicao.Itens.splice(idx, 1);
    }

    $scope.salvarComposicao = (composicao) => {
        if (composicao.Itens && composicao.Itens.length == 0) {
            MsgBox.Atencao("Atenção!", "Não é possível cadastrar composição sem item!", () => {}) ;
            return;
        }

        composicao.Novo = false

        var composicaoNova = {
            Id: composicao.Id,
            IdConstrucao: $scope.construcao.Id,
            Codigo: composicao.Codigo,
            Descricao: composicao.Descricao,
            Unidade: composicao.Unidade,
            Ordem: composicao.Ordem,
            Itens: []
        }

        composicao.Itens.filter(item => item.Id != 0).forEach(item => {
            if (item.Descricao.length == 0 ||
                item.Consumo.length == 0 ) {
                //item.CustoUnitario.length == 0) {
                MsgBox.Atencao("Atenção!", "Informação incompleta do item!", ()=>{})
                return;
            }

            composicaoNova.Itens.push({
                Id: item.Id,
                Consumo: item.Consumo,
                ValorUnitario: item.CustoUnitario
            });
        })

        if (composicao.Itens.some(item => item.Id == 0)) {
            var insumos = [];
            composicao.Itens.filter(item => item.Id == 0).forEach(
                item => {
                    insumos.push({
                        IdConstrucao: $scope.construcao.Id,
                        Id: 0,
                        Tipo: item.TipoSelecionado.Id,
                        Codigo: item.Codigo,
                        Nome: item.Material,
                        IdUnidade: item.IdUnidade,
                        Valor: item.CustoUnitario,
                        IdObraOrigem: item.IdConstrucao,
                        Importado: item.Importado == 1
                    })
                }
            )

            Material.setListaMateriais(insumos, 
                (idsInsumo) => {
                    composicao.Itens.filter(item => item.Id == 0).forEach(
                        (item,idx) => {
                            item.Id = idsInsumo.Instance[idx].IdMaterial
                            composicaoNova.Itens.push({
                                Id: item.Id,
                                Consumo: item.Consumo,
                                ValorUnitario: item.CustoUnitario
                            })
                        }
                    )
                    UploadApp.setComposicao(composicaoNova, $scope.construcao.Id,
                        (comp) => {
                            $scope.cancelarComposicao(composicao)
                            $scope.getComposicoes(() => {})
                        }
                    )
                }
            )


        } else {
            UploadApp.setComposicao(composicaoNova, $scope.construcao.Id,
                (comp) => {
                    $scope.cancelarComposicao(composicao)
                    $scope.getComposicoes(() => {});
                }
            )
        }

    }

    $scope.excluirComposicao = (composicao) => {
        MsgBox.Pergunta(composicao.Descricao, 'Confirma exclusão da composição?'
            , () => {
                var idx = $scope.composicoes.indexOf(composicao)
                $scope.composicoes.splice(idx, 1);
                Material.delMaterial($scope.construcao.Id, composicao.Id,
                    (data) => {
                    });
            }
            , () => {
            });
    }

    $scope.duplicaComposicao = (composicao) => {
        Construcao.duplicaComposicao($scope.construcao.Id, composicao.Id, 0, null,
            (data) => {
                $scope.getComposicoes(()=>{});
            });
    }

    $scope.getHtmlComposicao = function() {
        return `
        <form role="form" class="form" name="formComposicao">
            <div class="form-group">
                <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">
                    <input type="text" class="form-control" placeholder="Código" maxlength="20" ng-model="subItem.Codigo" ng-init="subItem.Codigo =  subItem.Codigo + ''">
                </div>
                <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">
                    <textarea class="form-control" placeholder="Nome da Composição" ng-model="subItem.Descricao" maxlength="2000" rows="6" required></textarea>
                </div>
                <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">
                    <select class="form-control" ng-model="subItem.Unidade" ng-init="subItem.Unidade = subItem.Unidade + ''" required>
                        <option value="" selected disabled> Unidade </option>
                        <option ng-repeat="unidade in listaUnidade" value="{{unidade.Sigla}}">{{unidade.Descricao}} ({{unidade.Sigla}})</option>
                    </select>
                </div>
                <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12 text-right"> 
                    <itemaddsub ng-click="adicionarInsumo(subItem)"></itemaddsub>
                    <itemsalvar ng-click="!formComposicao.$invalid && salvarComposicao(subItem)"></itemsalvar>
                    <itemcancelar ng-click="cancelarComposicao(subItem)"></itemcancelar>
                </div>
            </div>
        </form>`
    }

    /* EDITAR MATERIAL */

    $scope.adicionarInsumo = (composicao) => {
        var item = {
            IdCount: $scope.composicoes.length + 1,
            Id: 0,
            Tipo: '',
            Codigo: '',
            Unidade: '',
            Nome: '',
            Descricao: '',
            CustoUnitario: '',
            Consumo: '',
            Caminho: composicao.IdMaterial ? [composicao.IdMaterial] : undefined,
            Novo: true,
            HtmlEditarInsumo: $scope.getHtmlEditarInsumo()
        };

        composicao.Itens.unshift(item);
    }

    $scope.alterarInsumo = (item) => {
        item.UnidadeMedida = {Id: item.IdUnidade, Sigla: item.Unidade}
        item.TipoMaterial = {Id: item.Tipo, TipoDescricao: item.TipoDescricao}

        item.Selecionado = true;
        item.editando = !item.editando;
    }

    $scope.cancelarInsumo = (composicao, item) => {
        if (item.editando)
            item.editando = !item.editando;
        else {
            if (item.Novo) {
                var idx = composicao.Itens.indexOf(item);
                composicao.Itens.splice(idx, 1);
            }

            item.Novo = !item.Novo;
        }
    }

    $scope.setMaterial = (material, callBackFunction) => {
        Material.setMaterial($scope.construcao.Id, material,
            (data) => {
                var retorno = data.Instance[0];
                if (retorno.Codigo != 0) {
                    MsgBox.Atencao(material.Nome, retorno.Mensagem, null);
                    callBackFunction(null);
                }
                else {
                    callBackFunction(retorno.IdMaterial);
                }
            });
    }

    $scope.getTipoMaterial = () => {
        Material.getTipoMaterial(
            (data) => {
                $scope.listaTipoMaterial = data.Instance;
            });
    }


    $scope.salvarInsumo = (composicao, insumo) => {

        if (insumo.Novo)
            for (var i=1; i<composicao.Itens.length; i++)
                if (composicao.Itens[i].Id == insumo.Id) {
                    MsgBox.Atencao("Atenção!", "Insumo já anexado à composição, favor atualizar o quantitativo.", () => { });
                    return;
                }

        if (!insumo.Consumo && insumo.Consumo == undefined) {
            return;
        }

        var composicaoNova = {
            Id: composicao.IdMaterial ? composicao.IdMaterial : composicao.Id,
            IdConstrucao: $scope.construcao.Id,
            Codigo: composicao.Codigo,
            Descricao: composicao.Descricao,
            Unidade: composicao.UnidadeSigla ? composicao.UnidadeSigla : composicao.Unidade,
            Ordem: composicao.Ordem ? composicao.Ordem : '',
            Itens: []
        }

        composicao.Itens.forEach(item => {
            composicaoNova.Itens.push({
                Id: item.Id,
                Consumo: item.Consumo ? item.Consumo : item.Coeficiente,
                ValorUnitario: item.CustoUnitario ? item.CustoUnitario : item.ValorUnitario
            });
        });

        if (insumo.Selecionado) {
            insumo.editando = false;

            if (insumo.Novo == true) {
                insumo.Novo = false;
                $scope.setInsumoComposicao(composicao, insumo);
                return;
            } else {
                insumo.TipoDescricao = undefined;
                //var zero = 0.0
                var idUnidadeOld = null;

                for (var i in $scope.listaUnidade) {
                    if(insumo.Unidade == $scope.listaUnidade[i].Sigla){
                        idUnidadeOld = $scope.listaUnidade[i].Id;
                    }
                }

                var insumoAtualizar = {
                    Id: insumo.Id,
                    IdComposicao: composicaoNova.Id,
                    Tipo: insumo.TipoMaterial.Id,
                    TipoDescricao: insumo.TipoMaterial.Tipo,
                    Codigo: insumo.Codigo,
                    Nome: insumo.Nome ? insumo.Nome : insumo.Descricao,
                    IdUnidade: typeof(insumo.UnidadeMedida) != 'object' ? idUnidadeOld : insumo.UnidadeMedida.Id,
                    Unidade: typeof(insumo.UnidadeMedida) != 'object' ? insumo.Unidade : insumo.UnidadeMedida.Sigla,
                    Valor: insumo.ValorUnitario ? insumo.ValorUnitario : 0, //(insumo.CustoBDI ? (insumo.CustoBDI ? insumo.CustoBDI : insumo.Custo) : 0),
                    Coeficiente: insumo.Coeficiente
                }

                $scope.setMaterial(insumoAtualizar, (IdInsumo) => {
                        $scope.getComposicoes( () => {
                            $scope.getComposicaoUpdate(composicao)
                        });
                });
                return;
            }
        }

        if (!insumo.IdUnidade) {
            return;
        }

        if ((!insumo.CustoUnitario && insumo.CustoUnitario == undefined) && (!insumo.ValorUnitario && insumo.ValorUnitario == undefined)) {
            return;
        }

        insumo.editando = false;
        insumo.Novo = false;

        var insumoNovo = {
            Id: insumo.Id,
            Tipo: insumo.Tipo ? insumo.Tipo : insumo.TipoSelecionado.Id,
            Codigo: insumo.Codigo,
            Nome: insumo.Nome ? insumo.Nome : insumo.Descricao,
            IdUnidade: insumo.IdUnidade
        }

        insumoNovo.Valor = insumo.CustoUnitario;

        $scope.setMaterial(insumoNovo, (IdInsumo) => {
            if (!IdInsumo) {
                MsgBox.Atencao("Atenção!", "Erro ao efetuar o cadastro. Tente novamente, se persistir entre em contato com relacionamento Vigha.", () => { });
                return;
            }

            if (insumo.Id == 0)
                composicaoNova.Itens.filter(i => i.Id == 0)[0].Id = IdInsumo

            insumo.editando = false;
            insumo.Tipo = insumo.TipoSelecionado.Id;
            insumo.Id = IdInsumo;

            $scope.setInsumoComposicao(composicao, insumo);
        });

    }

    $scope.setUnidadeSigla = (detail) => {
        for (var i in $scope.listaUnidade)
            if ($scope.listaUnidade[i].Id == detail.IdUnidade) {
                detail.UnidadeSigla = $scope.listaUnidade[i].Sigla;
                break;
            }
    }

    /* override getLista(texto)  */
    $scope.getListaInsumo = (texto, item) => {
        item.Selecionado = false;
        item.Nome = texto;
        var base = $scope.listaComposicaoDisponivel.filter(l => l.Id.toString() == item.IdOrigem)[0];

        if (!base)
            base = {
                Origem: 0,
                UF: '',
                Periodo: ''
            }

        if (!base.Origem) {
            base.IdConstrucao = base.Id;
            base.Origem = 0;
        }

        Material.getListaMaterial((base.IdConstrucao || base.IdConstrucao == 0) ? base.IdConstrucao : $scope.construcao.Id, base.Origem, texto, base.UF, base.Periodo,
            (data) => {
                $scope.listaInsumo = [];
                var materiais = data.Instance;
                for (var i in materiais)
                    $scope.listaInsumo.push(materiais[i]);

                if ($scope.listaInsumo.length == 0)
                    item.Selecionado = false;

                $scope.listaInsumo.sort(
                    (a, b) => {
                        return a.IdConstrucao == $scope.construcao.Id ? -1 : (a.IdConstrucao > b.IdConstrucao ? 0 : 1)
                    }
                );

            });

    }

    /* override clickAdd()  */
    $scope.novoInsumo = () => {
        //CacheApp.setParaCadastro();
        //$location.path('/materiais');
    }

    /* override setSelecionado(selecionado)  */
    $scope.setSelecionadoInsumo = (selecionado, item) => {

        item.Id = selecionado.Id;
        item.Tipo = selecionado.Tipo;
        item.Nome = selecionado.Nome;
        item.UnidadeSigla = selecionado.UnidadeSigla;
        item.CustoUnitario = selecionado.Valor;
        item.IdObraOrigem = selecionado.IdConstrucao;
        item.Descricao = selecionado.Nome;
        item.Codigo = selecionado.Codigo;
        item.Origem = selecionado.Origem;

        if (selecionado.Origem == 0) {
            if (selecionado.Importado && selecionado.Importado == 1) 
                item.Importado = true; 
            else 
                item.Importado = false;
        }
        else {
            item.IdBasePublica = selecionado.IdBasePublica;
            item.UF = selecionado.UF;
            item.Periodo = selecionado.Periodo;
        }

        item.Selecionado = true;
    }

    $scope.getHtmlEditarInsumo = () => {
        return '' +
            '<form role="form" class="form" name="formInsumo">' +
            '   <div class="col-lg-10 col-md-10 col-sm-10 col-xs-12">' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Base</label>' +
            `                   <select class="form-control" ng-model="detail.IdBaseOrigem" ng-init="detail.IdBaseOrigem = sessao.BasePublica ? sessao.BasePublica.IdBaseOrigem : '0'" ng-change="getComposicaoDisponivel(detail)">` +
            '                       <option ng-repeat="base in listaOrigemDisponivel" value="{{base.Id}}">{{base.Nome}}</option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="col-lg-9 col-md-9 col-sm-9 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            `                   <label>{{detail.IdBaseOrigem == 0 ? 'Obras' : 'Período'}}</label>` +
            `                   <select class="form-control" ng-model="detail.IdOrigem"  ng-init="detail.IdOrigem = sessao.BasePublica ? sessao.BasePublica.IdOrigem : '0'" ng-change="setBaseSessao(detail)">` +
            '                       <option ng-repeat="base in listaComposicaoDisponivel" value="{{base.Id}}">{{base.Descricao}}</option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="row col-lg-12 col-md-12 col-sm-12 col-xs-12">&nbsp;</div>' +
            '               <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Insumo</label>'+
            '                   <dropdowncomplete' +
            '                       ddc-placeholder="\'Digite o Insumo\'"' +
            '                       ddc-mensagemvazio="\'NENHUM INSUMO ENCONTRADO\'"' +
            '                       ddc-showcodigo="true"' +
            '                       ddc-showvalor="true"' +
            '                       ddc-hideadd="true"' +
            '                       ddc-construcao="construcao"' +
            '                       ddc-item="detail"' +
            '                       ddc-lista="listaInsumo"' +
            '                       set-selecionado="setSelecionadoInsumo(selecionado,detail)"' +
            '                       get-lista="getListaInsumo(texto,detail)"' +
            '                       click-add="novoInsumo()">' +
            '                   </dropdowncomplete>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Consumo {{!detail.UnidadeSigla ? "" : ("("+detail.UnidadeSigla+")")}}</label>' +
            '					<input type="text" class="form-control" placeholder="Consumo" ng-model="detail.Consumo" ui-number-mask="7" required>' +
            '               </div>' +
            '				<div class="col-lg-2 col-md-2 col-sm-4 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Preço ({{construcao.Moeda}})</label>' +
            '					<div class="text-left panel-fonticon" ng-show="detail.Selecionado">' +
            '					    <formata-numero format-valor="detail.CustoUnitario" format-tipo="\'real\'"></formata-numero>' +
            '					</div>' +
            '                   <input type="text" class="form-control" placeholder="Valor Unitário (R$)" maxlength="16" ng-model="detail.CustoUnitario" ui-number-mask="decimals" ng-show="!detail.Selecionado" required>' +
            '               </div>' +
            '               <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <label>Tipo Insumo</label>'+
            '                   <select class="form-control"' +
            '                       ng-model="detail.TipoSelecionado"' +
            '                       ng-options="tipo.Descricao for tipo in listaTipoMaterial track by tipo.Id" required>' +
            '                       <option style="display:none" value=""> Selecione o tipo </option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <br class="showMobile" />' +
            '                   <label>Unidade</label>'+
            '	                <select class="form-control" ng-model="detail.IdUnidade" ng-init="detail.IdUnidade = detail.IdUnidade + \'\'" ng-change="setUnidadeSigla(detail)" required>' +
            '	                    <option value="" selected disabled> Unidade de referência </option>' +
            '	                    <option ng-repeat="unidade in listaUnidade" value="{{unidade.Id}}">{{unidade.Descricao}} ({{unidade.Sigla}})</option>' +
            '	                </select>' +
            '               </div>' +
            '               <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <br class="showMobile" />' +
            '                   <label>Código</label>'+
            '	                <input type="text" class="form-control" placeholder="Código" maxlength="20" ng-model="detail.Codigo"/>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '   </div>' +
            '   <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12 text-center">' +
            '       <div class="row">' +
            '           <itemsalvar ng-show="!subItem.Novo" ng-click="salvarInsumo(subItem, detail); $event.stopPropagation();" ></itemsalvar>' +
            '           <itemcancelar ng-click="cancelarInsumo(subItem, detail); $event.stopPropagation();"></itemcancelar>' +
            '		</div>' +
            '       <div class="row text-center"><br />' +
            '           <label>Total</label>' +
            '			<div class="panel-fonticon">' +
            '			    <formata-numero format-valor="detail.Consumo*detail.CustoUnitario" format-tipo="\'real\'"></formata-numero>' +
            '			</div>' +
            '		</div>' +
            '   </div>' +
            '</form>';
    }

    $scope.getInsumoComp = (composicao) => {
        composicao.open = !composicao.open;
        if (composicao.open) {
            var caminho = composicao.Caminho ? composicao.Caminho.filter(c => c != 0) : [];
            caminho.push(composicao.Id);
            composicao.Itens = $scope.composicoes.filter(c => c.Id == composicao.Id)[0].Itens;
            composicao.Itens.forEach(i => {
                i.Caminho = caminho;
            })
            composicao.HtmlListaInsumoComp = $scope.getHtmlListaInsumoComp(composicao);
        }
        else
            composicao.HtmlListaInsumoComp = '';
    }
    
    $scope.addInsumoCompAux = (detail) => {
        var caminho = detail.Caminho.filter(c => c != 0);
        caminho.push(detail.Id);
        var item = {
            IdCount: $scope.orcamento.length + 1,
            Id: 0,
            Tipo: '',
            Codigo: '',
            Unidade: '',
            Nome: '',
            Descricao: '',
            CustoUnitario: '',
            Consumo: '',
            Caminho: caminho,
            Novo: true
        };

        detail.Itens.unshift(item);
        item.HtmlEditarInsumo = $scope.getHtmlEditarInsumoComp(detail);
    }

    $scope.setInsumoComposicao = (composicao, item) => {

        var insumoComp = {
            IdConstrucao: $scope.construcao.Id,
            IdObraOrigem: item.IdObraOrigem ? item.IdObraOrigem : $scope.construcao.Id,
            IdComposicao: composicao.Id ? composicao.Id : composicao.IdMaterial,
            IdMaterial: item.Id,
            Coeficiente: item.Consumo,
            Tipo: item.Tipo ? item.Tipo : 1
        }

        if (item.Origem == 0)
            insumoComp.Importado = item.Importado;
        else {
            insumoComp.IdBasePublica = item.IdBasePublica;
            insumoComp.UF = item.UF;
            insumoComp.Periodo = item.Periodo;
        }


        item.editando = false;
        Material.setInsumoComposicao(insumoComp, 
            (data) => {
                if (data.Code == 0) {
                    $scope.getComposicoes(() => {
                        $scope.getComposicaoUpdate(composicao);
                    });
                }
            }
        );

    }

    $scope.delInsumoComp = (composicao, insumo) => {

        function delInsumoComposicao (params) {
            Material.delInsumoComposicao(params, () => {
                $scope.getComposicoes(() => {
                    $scope.getComposicaoUpdate(composicao);
                });
            });
        }

        var params = {
            IdConstrucao: $scope.construcao.Id,
            IdComposicao: composicao.Id ? composicao.Id : composicao.IdMaterial,
            IdMaterial: insumo.Id
        }
        
        if (composicao.Itens.length-1 == 0)
            MsgBox.Pergunta('Atenção', 'A exclusão do ' + insumo.TipoDescricao + ' implicará na exclusão da composição que poderá impactar no orçamento, no financeiro e na medição física.  Confirma exclusão?'
                , () => {
                    var idx = $scope.composicoes.findIndex(i => i.IdCompra == composicao.IdCompra);
                    $scope.composicoes.splice(idx, 1);
    
                    Material.delMaterialOrcamento(composicao.IdCompra,
                        (data) => {
                            $scope.getComposicoes(() => {});
                        }
                    );
    
                }
                , () => {
            });
        else {
            var idx = composicao.Itens.findIndex(i => i.Id == insumo.Id);
            composicao.Itens.splice(idx, 1);
            delInsumoComposicao(params);
        }
    }

    $scope.getHtmlListaInsumoComp = (composicao) => {
        $scope.composicaoListaInsumos = composicao;
        var IdComp = composicao.Id;
        var retorno = '' +
            '<br />' +
            '<div class="panel panel-insumo sombreado">' +
            '<div class="panel-heading tr-fonteTitulo">' +
            '    <div class="row">' +
            '	<div class="col-lg-6 col-md-6 col-sm-6">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Tipo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Código' +
            '		</div>' +
            '		<div class="col-lg-6 col-md-6 col-sm-6 text-left">' +
            '	        Insumo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '	        Unidade' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '	<div class="col-lg-6 col-md-6 col-sm-6 text-right">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Preço' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Consumo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Custo' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    Total' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '    </div>' +
            '</div>' +
            '<ul class="list-group tr-fonteItem">';

        retorno += 
            `<ul class="list-group tr-fonteItem" ng-init="composicao${IdComp} = composicaoListaInsumos">` +
            `    <li class="list-group-item" ng-class="{'LinhaLista': detail.Tipo != 4, 'LinhaListaHand': detail.Tipo == 4}" ng-repeat="detail in composicao${IdComp}.Itens" ng-mouseover="mouseoverinsumo${IdComp}= (true && detail.TipoDescricao)" ng-mouseleave="mouseoverinsumo${IdComp}=false" ng-click="(detail.Tipo == 4 && !detail.Novo && !detail.editando && getInsumoComp(detail)); $event.stopPropagation();">` +
            '	<div class="row" ng-show="!detail.Novo && !detail.TipoDescricao">' +
            '           <loadcirclesmall ng-show="!detail.TipoDescricao"></loadcirclesmall>' +
            '	</div>' +
            '	<div class="row" ng-show="!detail.Novo && detail.TipoDescricao">' +
            '	<div class="col-lg-6 col-md-6 col-sm-6">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '		    <div ng-show="(!detail.editando && detail.Tipo != 4) || detail.Tipo == 4">{{detail.TipoDescricao}}</div>' +
            '           <select class="form-control input-sm" style="height:22px; font-size:9px"' +
            '                   ng-model="detail.TipoMaterial"' +
            '                   ng-show="detail.editando && detail.Tipo != 4"' +
            '                   ng-options="tipo.Nome for tipo in listaTipoMaterial track by tipo.Id" required>' +
            '               <option style="display:none" value=""> Selecione o tipo </option>' +
            '           </select>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            `		<div ng-show="!detail.editando" ng-class="{'texto': !detail.open, 'textoBold': detail.open}">{{detail.Codigo}}</div>` +
            '       <input ng-show="detail.editando" type="text" style="text-align: left;" class="form-control input-xs text-left" placeholder="Código" ng-model="detail.Codigo" ng-keyup="detail.Codigo = detail.Codigo" >' +
            '		</div>' +
            '		<div class="col-lg-6 col-md-6 col-sm-6 text-left">' +
            `		<div ng-show="!detail.editando" ng-class="{'texto': !detail.open, 'textoBold': detail.open}">{{detail.Descricao}}</div>` +
            `       <textarea ng-show="detail.editando" style="text-align: left;" class="form-control input-xs" placeholder="Descrição" ng-model="detail.Descricao" maxlength="2000" rows="6" required></textarea>` +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2 text-center">' +
            '		    <div ng-show="!detail.editando">{{detail.Unidade}}</div>' +
            '	        <select class="form-control input-sm" style="height:22px; font-size:9px"'+
            '                   ng-model="detail.UnidadeMedida" '+
            '                   ng-show="detail.editando"'+
            '                   ng-options="unidade.TextoUnidadeView for unidade in listaUnidade track by unidade.Id" required>' +
            '	            <option style="display:none" value=""> Unidade de referência </option>' +
            '	        </select>' +
            '		    </div>' +
            '	    </div>' +
            '	</div>' +
            '	<div class="col-lg-6 col-md-6 col-sm-6 text-right">' +
            '	    <div class="row">' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero ng-show="(!detail.editando && detail.Tipo != 4) || detail.Tipo == 4" format-valor="detail.ValorUnitario" format-tipo="\'real\'"></formata-numero>' +
            '           <input ng-show="detail.editando && detail.Tipo != 4" type="text" class="form-control input-xs" placeholder="Valor Unitário (R$)" maxlength="16" ng-model="detail.ValorUnitario" ng-keyup="detail.CustoUnitario = detail.ValorUnitario" ui-number-mask="decimals" required>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero ng-show="!detail.editando" format-valor="detail.Coeficiente" format-tipo="\'coeficiente\'"></formata-numero>' +
            '           <input ng-show="detail.editando" type="text" class="form-control input-xs" placeholder="Consumo" ng-model="detail.Consumo" ng-init="detail.Consumo = detail.Coeficiente" ng-keyup="detail.Coeficiente = detail.Consumo" ui-number-mask="7" required>' +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '			<formata-numero format-valor="detail.Coeficiente*detail.ValorUnitario" format-tipo="\'real\'"></formata-numero>' +
            '		</div>' +
            `		<div class="col-lg-2 col-md-2 col-sm-2">` +
            '		</div>' +
            `		<div class="col-lg-2 col-md-2 col-sm-2">` +
            '		</div>' +
            '		<div class="col-lg-2 col-md-2 col-sm-2">' +
            '		    <formata-numero format-valor="detail.Coeficiente*detail.ValorUnitario" format-tipo="\'real\'"></formata-numero>' +
            '		</div>' +
            '	    </div>' +
            `	    <div class="row" ng-show="(!detail.editando && mouseoverinsumo${IdComp}) || detail.editando || detail.open">` +
            `		<div class="col-lg-12 col-md-12 col-sm-12 text-right">` +
            '           <div ng-show="!detail.editando">' +
            `               <itemaddsub ng-show="detail.Tipo == 4 && detail.open" ng-click="addInsumoCompAux(detail); $event.stopPropagation();" btn-permissao="'SET_ORCAMENTO'" btn-acessos="construcao.Acessos"></itemaddsub>` +
            '               <itemeditar ng-show="!detail.open" ng-click="alterarInsumo(detail); $event.stopPropagation();" btn-permissao="\'SET_ORCAMENTO\'" btn-acessos="construcao.Acessos"></itemeditar>' +
            `               <itemexcluir ng-show="!detail.open" ng-click="delInsumoComp(composicao${IdComp}, detail); $event.stopPropagation();" btn-permissao="\'DEL_ORCAMENTO\'" btn-acessos="construcao.Acessos"></itemexcluir>` +
            '               <itemabrir ng-show="detail.Tipo == 4 && !detail.open" ng-click="(detail.Tipo == 4 && !detail.Novo && !detail.editando && getInsumoComp(detail)); $event.stopPropagation();"></itemabrir>' +
            '               <itemfechar ng-show="detail.Tipo == 4 && detail.open" ng-click="(detail.Tipo == 4 && !detail.Novo && !detail.editando && getInsumoComp(detail)); $event.stopPropagation();"></itemfechar>' +
            '		    </div>' +
            '           <div ng-show="detail.editando">' +
            `               <itemsalvar ng-click="salvarInsumo(composicao${IdComp}, detail); $event.stopPropagation();" ></itemsalvar>` +
            `               <itemcancelar ng-click="cancelarInsumo(composicao${IdComp}.Itens,detail); $event.stopPropagation();"></itemcancelar>` +
            '		    </div>' +
            '		</div>' +
            '	    </div>' +
            '	</div>' +
            '	</div>' +
            '	<div class="row" ng-show="detail.Novo">' +
            '     <div class="notShowMobile" dynamic="detail.HtmlEditarInsumo"></div>' +
            '	</div>' +
            '	<div>' +
            '     <div class="notShowMobile" dynamic="detail.HtmlListaInsumoComp"></div>' +
            '	</div>' +
            '    </li>' +
            '</ul>' +
            '</div>';

    
        return retorno;
    }

    $scope.getHtmlEditarInsumoComp = (composicao) => {
        $scope.composicaoAuxListaInsumos = composicao;
        return '' +
            `<form role="form" class="form" name="formInsumo">` +
            '   <div class="col-lg-10 col-md-10 col-sm-10 col-xs-12">' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Base</label>' +
            `                   <select class="form-control" ng-model="detail.IdBaseOrigem" ng-init="detail.IdBaseOrigem = sessao.BasePublica ? sessao.BasePublica.IdBaseOrigem : '0'" ng-change="getComposicaoDisponivel(detail)">` +
            '                       <option ng-repeat="base in listaOrigemDisponivel" value="{{base.Id}}">{{base.Nome}}</option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="col-lg-9 col-md-9 col-sm-9 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            `                   <label>{{detail.IdBaseOrigem == 0 ? 'Obras' : 'Período'}}</label>` +
            `                   <select class="form-control" ng-model="detail.IdOrigem"  ng-init="detail.IdOrigem = sessao.BasePublica ? sessao.BasePublica.IdOrigem : '0'" ng-change="setBaseSessao(detail)">` +
            '                       <option ng-repeat="base in listaComposicaoDisponivel" value="{{base.Id}}">{{base.Descricao}}</option>' +
            '                   </select>' +
            '               </div>' +
            '			    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '                   <label>Insumo</label>'+
            '                   <dropdowncomplete' +
            '                       ddc-placeholder="\'Digite o Insumo\'"' +
            '                       ddc-mensagemvazio="\'NENHUM INSUMO ENCONTRADO\'"' +
            '                       ddc-showcodigo="true"' +
            '                       ddc-showvalor="true"' +
            '                       ddc-hideadd="true"' +
            '                       ddc-construcao="construcao"' +
            '                       ddc-item="detail"' +
            '                       ddc-lista="listaInsumo"' +
            '                       set-selecionado="setSelecionadoInsumo(selecionado,detail)"' +
            '                       get-lista="getListaInsumo(texto,detail)"' +
            '                       click-add="novoInsumo()">' +
            '                   </dropdowncomplete>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '       <div class="form-group">' +
            '           <div class="row">' +
            '               <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Consumo {{!detail.UnidadeSigla ? "" : ("("+detail.UnidadeSigla+")")}}</label>' +
            '					<input type="text" class="form-control" placeholder="Consumo" ng-model="detail.Consumo" ui-number-mask="7" required>' +
            '               </div>' +
            '				<div class="col-lg-2 col-md-2 col-sm-4 col-xs-12">' +
            '                   <div class="showMobile"><br /></div>' +
            '					<label>Preço ({{construcao.Moeda}})</label>' +
            '					<div class="text-left panel-fonticon" ng-show="detail.Selecionado">' +
            '					    <formata-numero format-valor="detail.CustoUnitario" format-tipo="\'real\'"></formata-numero>' +
            '					</div>' +
            '                   <input type="text" class="form-control" placeholder="Valor Unitário (R$)" maxlength="16" ng-model="detail.CustoUnitario" ui-number-mask="decimals" ng-show="!detail.Selecionado" required>' +
            '               </div>' +
            '               <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <label>Tipo Insumo</label>'+
            '                   <select class="form-control"' +
            '                       ng-model="detail.TipoSelecionado"' +
            '                       ng-options="tipo.Descricao for tipo in listaTipoMaterial track by tipo.Id" required>' +
            '                       <option style="display:none" value=""> Selecione o tipo </option>' +
            '                   </select>' +
            '               </div>' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <br class="showMobile" />' +
            '                   <label>Unidade</label>'+
            '	                <select class="form-control" ng-model="detail.IdUnidade" ng-init="detail.IdUnidade = detail.IdUnidade + \'\'" ng-change="setUnidadeSigla(detail)" required>' +
            '	                    <option value="" selected disabled> Unidade de referência </option>' +
            '	                    <option ng-repeat="unidade in listaUnidade" value="{{unidade.Id}}">{{unidade.Descricao}} ({{unidade.Sigla}})</option>' +
            '	                </select>' +
            '               </div>' +
            '               <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12" ng-show="!detail.Selecionado">' +
            '                   <br class="showMobile" />' +
            '                   <label>Código</label>'+
            '	                <input type="text" class="form-control" placeholder="Código" maxlength="20" ng-model="detail.Codigo"/>' +
            '               </div>' +
            '           </div>' +
            '       </div>' +
            '   </div>' +
            '   <div class="col-lg-2 col-md-2 col-sm-2 col-xs-12 text-center">' +
            '       <div class="row">' +
            '           <itemsalvar ng-click="salvarInsumo(composicaoAuxListaInsumos, detail); $event.stopPropagation();" ></itemsalvar>' +
            `           <itemcancelar ng-click="cancelarInsumo(composicaoAuxListaInsumos, detail); $event.stopPropagation();"></itemcancelar>` +
            '		</div>' +
            '       <div class="row text-center"><br />' +
            '           <label>Total</label>' +
            '			<div class="panel-fonticon">' +
            '			    <formata-numero format-valor="detail.Consumo*detail.CustoUnitario" format-tipo="\'real\'"></formata-numero>' +
            '			</div>' +
            '		</div>' +
            '   </div>' +
            '</form>';
    }    
    /* FIM EDITAR MATERIAL* */

      $scope.getListaConstrucao = (callBack) => {
        var params = {
            permissao: ($scope.sessao.TipoPlano == 1 || $scope.sessao.ContaAdmin) ? undefined : 'GET_COMPOSICAO',
            refresh: $scope.refreshObra ? true: false
        }
        $scope.getListaObraCache(params, 
            (obra)=> {
                $scope.construcoes = obra
                callBack()
            }
        )
    }

    $scope.filtraObra = (obra) => {
        if (obra && obra.id) {
            $scope.setObraSelecionada($scope.construcoes.filter(c => c.Id == obra.id)[0])
        }
        else {
            $scope.composicoes = undefined;
            $scope.construcao = undefined;
            CacheApp.delConstrucao();
        }
    }

    $scope.setObraSelecionada = (obra) => {
        $scope.composicoes = undefined
        $scope.construcao = obra
        CacheApp.setConstrucao($scope.construcao)

        $scope.HtmlManterObra = undefined

        $scope.loadMain()
    }

    $scope.editarObra = () => {
        if (!$scope.HtmlManterObra)
            $scope.HtmlManterObra = `
                <manterobra mo-obra="construcao">
                </manterobra>
            `;
        $scope.openObra = !$scope.openObra;
    }

    $scope.salvarObra = () => {
        $rootScope.$broadcast('salvarObra', {});
    }

    $scope.$on('refreshComboObra', (events,args) => {
        $scope.refreshObra = true
        $scope.loadObra()
    })

    $scope.loadMain = () => {
        $scope.getOrigemBase()
        // $scope.getComposicoes(()=>{})
        $scope.aplicaFiltro()
        $scope.getListaUnidades()
        $scope.getTipoMaterial()
    }

    $scope.loadObra = () => {
        $scope.ObraSelecionada = CacheApp.getConstrucao()
        CacheApp.delConstrucao()
        $scope.AtualizaConstrucao()
        $scope.getListaConstrucao(()=>{
            if ($scope.ObraSelecionada && $scope.construcoes.some(c => c.Id == $scope.ObraSelecionada.Id)) {
                $scope.listaSelecao = {
                    id: $scope.ObraSelecionada.Id, 
                    model: $scope.ObraSelecionada.Titulo, 
                    label: $scope.ObraSelecionada.Titulo,
                    checked: true
                }
                $scope.setObraSelecionada($scope.ObraSelecionada)
            }
            else
                $scope.composicoes = []
        })
    }

    $scope.AcessoAndroid($routeParams, (sim) => {
        $scope.AcessoMobile = sim;
        $scope.sessao = CacheApp.getSessao();

        $scope.loadObra()
    })

  }]);
